#ifndef MAINWIDGET_H
#define MAINWIDGET_H

#include <QWidget>

class QStackedLayout;
class MenuWidget;
class GameWidget;

class MainWidget: public QWidget
{
    Q_OBJECT

public:

    MainWidget( QWidget* aParent = 0 );

private slots:

    void pauseGame();

    void newGame();

    void resumeGame();

signals:

    void start();

private:

    void disableDisplayOff();

private:

    QStackedLayout* mStackedLayout;
    MenuWidget* mMenuPage;    
    GameWidget* mGamePage;

};

#endif // MAINWIDGET_H
